class Library:

    def __init__(self):
        # master vector of word
        self.words = []
        self.counts = {}

    def ComputeStats(self):
        # assert self.counts == {}
        for i in range(18):
            self.counts[i] = []
        for s in self.words:
            _len = len(s)
            if _len <= 18:
                self.counts[_len-1].append(_len)

    def PrintStats(self):
        print("Here are the counts of each word length")
        for k,v in self.counts.items():
            # print(v)
            if k != 0:
                print(f"[{k}] {len(v)}")

    def GetWord(self, i):
        assert (i >= 0 and i < len(self.words))
        return self.words[i]

    def ReadFromFile(self, filename):
        with open(filename, 'r') as f:
            for line in f:
                self.words.append(line)
        print(f"Read {len(self.words)} words from file '{filename}'")


class Grid:

    def __init__(self, n):
        self.name = n
        self.lines = []

    def rows(self):
        return len(self.lines)

    def cols(self):
        if self.lines == []:
            return 0
        else:
            return len(self.lines[0])

    def LoadFromFile(self, filename):
        with open(filename, 'r') as f:
            for line in f:
                #print(f"{line.rstrip()} ({len(line.rstrip())})")        
                if not line.startswith('#'):
                    self.lines.append(list(line.rstrip()))

    def Check(self):
        for s in self.lines:
            assert len(s) == self.cols()

    def Print(self):
        print(f"Grid: {self.name} "
              f"(rows={self.rows()},"
              f" cols={self.cols()})")
        for s in self.lines:
            print(f"  {''.join(s)}")

if __name__ == "__main__":
    lib = Library()
    lib.ReadFromFile("top_12000.txt")
    lib.ComputeStats()
    lib.PrintStats()

    # grid = Grid("MY GRID")
    # grid.LoadFromFile("test")
    # grid.Check()
    # grid.Print()